from modelservicecontext import EModelContextStatus
from modelservicecontext import ERequestResponseDataFlag
from modelservicecontext import ERequestResponseDataMIME
from modelservicecontext import ModelServiceContext
from modeldatahandler import ModelDataHandler
import sys
import os
import shutil
import linecache

# Begin
if len(sys.argv) < 4:
	exit()

ms = ModelServiceContext()
ms.onInitialize(sys.argv[1], sys.argv[2], sys.argv[3])
mdh = ModelDataHandler(ms)

print(ms.getMappingLibraryDirectory())

# assembly folder
current_dir = os.path.abspath(os.path.dirname(__file__))
assembly_dir = os.path.dirname(current_dir) + '\\assembly\\'
print(assembly_dir)

# create instance folder
instance_dir = ms.getModelInstanceDirectory()
if not os.path.exists(instance_dir):
    os.makedirs(instance_dir)

print(instance_dir[0:2])
for file in os.listdir(assembly_dir):
	source_file = os.path.join(assembly_dir, file)
	# copy file 
	shutil.copy(source_file, instance_dir)

######################################################################

# Enter State
ms.onEnterState('BasicInput')

# Event - input data
ms.onFireEvent('Define_input')

ms.onRequestData()

data_Define_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Define_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Define_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Define_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Define_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

startDay = int(linecache.getline(data_Define_input,7)[:].replace('\n',''))
endDay = int(linecache.getline(data_Define_input,8)[:].replace('\n',''))

shutil.move(data_Define_input, instance_dir + "define.txt")
	
# Event - input data
ms.onFireEvent('Grid_input')

ms.onRequestData()

data_Grid_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Grid_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Grid_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Grid_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Grid_input = ms.getRequestDataBody()
else:
	ms.onFinalize()
	
shutil.move(data_Grid_input, instance_dir + "heihe-grid.inf")
# Event - input data
ms.onFireEvent('Curve_lib_input')

ms.onRequestData()

data_Curve_lib_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Curve_lib_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Curve_lib_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Curve_lib_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Curve_lib_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_Curve_lib_input, instance_dir + "heihe-lib.inf")

# Leave State
ms.onLeaveState()

######################################################################

# Enter State
ms.onEnterState('AquiferFlowInput')

# Event - input data
ms.onFireEvent('Setting_input')

ms.onRequestData()

data_Setting_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Setting_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Setting_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Setting_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Setting_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

# setting_input = open(data_Setting_input, mode='r')
# print(setting_input.readline())


observe_input = linecache.getline(data_Setting_input,5)[2:].replace('\n','')
inBound_input = linecache.getline(data_Setting_input,6)[2:].replace('\n','')
modelCtrl_input = linecache.getline(data_Setting_input,7)[2:].replace('\n','')
grdDat_Ksx_input = linecache.getline(data_Setting_input,10)[2:].replace('\n','')
grdDat_Ksy_input = linecache.getline(data_Setting_input,13)[2:].replace('\n','')
grdDat_Ksv_input = linecache.getline(data_Setting_input,16)[2:].replace('\n','')
grdDat_Ss_input = linecache.getline(data_Setting_input,19)[2:].replace('\n','')
grdDat_nVoid_input = linecache.getline(data_Setting_input,22)[2:].replace('\n','')
grdDat_IdFlow_input = linecache.getline(data_Setting_input,40)[2:].replace('\n','')
grdDat_H0_input = linecache.getline(data_Setting_input,43)[2:].replace('\n','')

# setting_input.close()

shutil.move(data_Setting_input, instance_dir + "heihe-aq.inf")
# Event - input data
ms.onFireEvent('Observe_input')

ms.onRequestData()

data_Observe_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Observe_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Observe_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Observe_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Observe_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_Observe_input, instance_dir + observe_input)

# Event - input data
ms.onFireEvent('InBound_input')

ms.onRequestData()

data_InBound_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_InBound_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_InBound_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_InBound_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_InBound_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_InBound_input, instance_dir + inBound_input)	
# Event - input data
ms.onFireEvent('ModelCtrl_input')

ms.onRequestData()

data_ModelCtrl_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_ModelCtrl_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_ModelCtrl_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_ModelCtrl_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_ModelCtrl_input = ms.getRequestDataBody()
else:
	ms.onFinalize()
shutil.move(data_ModelCtrl_input, instance_dir + modelCtrl_input)

# Event - input data
ms.onFireEvent('GrdDat_Ksx_input')

ms.onRequestData()

data_GrdDat_Ksx_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_Ksx_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_Ksx_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_Ksx_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_Ksx_input = ms.getRequestDataBody()
else:
	ms.onFinalize()
shutil.move(data_GrdDat_Ksx_input, instance_dir + grdDat_Ksx_input)

# Event - input data
ms.onFireEvent('GrdDat_Ksy_input')

ms.onRequestData()

data_GrdDat_Ksy_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_Ksy_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_Ksy_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_Ksy_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_Ksy_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_GrdDat_Ksy_input, instance_dir + grdDat_Ksy_input)

# Event - input data
ms.onFireEvent('GrdDat_Ksv_input')

ms.onRequestData()

data_GrdDat_Ksv_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_Ksv_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_Ksv_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_Ksv_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_Ksv_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_GrdDat_Ksv_input, instance_dir + grdDat_Ksv_input)

# Event - input data
ms.onFireEvent('GrdDat_Ss_input')

ms.onRequestData()

data_GrdDat_Ss_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_Ss_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_Ss_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_Ss_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_Ss_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_GrdDat_Ss_input, instance_dir + grdDat_Ss_input)

# Event - input data
ms.onFireEvent('GrdDat_nVoid_input')

ms.onRequestData()

data_GrdDat_nVoid_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_nVoid_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_nVoid_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_nVoid_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_nVoid_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_GrdDat_nVoid_input, instance_dir + grdDat_nVoid_input)

# Event - input data
ms.onFireEvent('GrdDat_IdFlow_input')

ms.onRequestData()

data_GrdDat_IdFlow_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_IdFlow_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_IdFlow_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_IdFlow_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_IdFlow_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_GrdDat_IdFlow_input, instance_dir + grdDat_IdFlow_input)

# Event - input data
ms.onFireEvent('GrdDat_H0_input')

ms.onRequestData()

data_GrdDat_H0_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_GrdDat_H0_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_GrdDat_H0_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_GrdDat_H0_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_GrdDat_H0_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_GrdDat_H0_input, instance_dir + grdDat_H0_input)

# Leave State
ms.onLeaveState()
######################################################################

# Enter State
ms.onEnterState('AqSSTInput')

# Event - input data
ms.onFireEvent('Setting_input')

ms.onRequestData()

data_Setting_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	data_Setting_input = ms.getRequestDataBody()
else:
	ms.onFinalize()


pump_input = linecache.getline(data_Setting_input,5)[2:].replace('\n','')
recharge_input = linecache.getline(data_Setting_input,8)[2:].replace('\n','')
river_input = linecache.getline(data_Setting_input,11)[2:].replace('\n','')

shutil.move(data_Setting_input, instance_dir + "heihe-SST.inf")

# Event - input data
ms.onFireEvent('Pump_input')

ms.onRequestData()

data_Pump_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Pump_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Pump_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Pump_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Pump_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_Pump_input, instance_dir + pump_input)

# Event - input data
ms.onFireEvent('Recharge_input')

ms.onRequestData()

data_Recharge_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_Recharge_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_Recharge_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_Recharge_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_Recharge_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_Recharge_input, instance_dir + recharge_input)

# Event - input data
ms.onFireEvent('River_input')

ms.onRequestData()

data_River_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# input data is zip
	if ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_ZIP_FILE:
		# get input data
		data_River_input = ms.getRequestDataBody()
	# input data is raw data
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_RAW_FILE:
		# get input data
		data_River_input = ms.getRequestDataBody()
	# input data is in UDX format
	elif ms.getRequestDataMIME() == ERequestResponseDataMIME.ERDM_XML_FILE:
		# get input data
		data_River_input = ms.getRequestDataBody()
	# input data is in other formats
	else:
		# get input data
		data_River_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_River_input, instance_dir + river_input)

# Leave State
ms.onLeaveState()

######################################################################

# Enter State
ms.onEnterState('SiB2Input')

# Event - input data
ms.onFireEvent('station_force_input')

ms.onRequestData()

data_station_force_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_station_force_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_station_force_input, instance_dir + "station_force.txt")

# Event - input data
ms.onFireEvent('station_lai_input')

ms.onRequestData()

data_station_lai_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_station_lai_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_station_lai_input, instance_dir + "station_lai.txt")

# Event - input data
ms.onFireEvent('station_vegsoil_input')

ms.onRequestData()

data_station_vegsoil_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_station_vegsoil_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_station_vegsoil_input, instance_dir + "station_vegsoil.txt")

# Event - input data
ms.onFireEvent('vegtype_input')

ms.onRequestData()

data_vegtype_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_vegtype_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_vegtype_input, instance_dir + "heihe_vegtype.asc")

# Event - input data
ms.onFireEvent('vcover_input')

ms.onRequestData()

data_vcover_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_vcover_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_vcover_input, instance_dir + "heihe_vcover.asc")

# Event - input data
ms.onFireEvent('veglib_sib_input')

ms.onRequestData()

data_veglib_sib_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_veglib_sib_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_veglib_sib_input, instance_dir + "veglib_sib.txt")

# Event - input data
ms.onFireEvent('clay1_input')

ms.onRequestData()

data_clay1_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_clay1_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_clay1_input, instance_dir + "heihe_clay1.asc")

# Event - input data
ms.onFireEvent('sand1_input')

ms.onRequestData()

data_sand1_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_sand1_input = ms.getRequestDataBody()
else:
	ms.onFinalize()

shutil.move(data_sand1_input, instance_dir + "heihe_sand1.asc")

monday=[31,29,31,30,31,30,31,31,30,31,30,31]
days=startDay
for m in range (12):
	if days<=monday[m]-1:
		break
	else:
		days-=monday[m]
month = m+1
day = days+1


# Event - input data
ms.onFireEvent('force_data_input')

ms.onRequestData()

data_force_data_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_force_data_input = ms.getRequestDataBody()
else:
	ms.onFinalize()


# Event - input data
ms.onFireEvent('lai_data_input')

ms.onRequestData()

data_lai_data_input = None
if ms.getRequestDataFlag() == ERequestResponseDataFlag.ERDF_OK:
	# get input data
	data_lai_data_input = ms.getRequestDataBody()
else:
	ms.onFinalize()


force_data_lines = None
with open(data_force_data_input, 'r') as f:
	force_data_lines = f.readlines()

lai_data_lines = None
with open(data_lai_data_input, 'r') as f:
	lai_data_lines = f.readlines()

force_startLine = 0
lai_startLine = 0
for i in range(len(force_data_lines)):
	if force_data_lines[i].strip()=='' or i == len(force_data_lines)-1:
		fileName = "%4d-%02d-%02d" % (2008, month, day)
		with open(instance_dir+fileName+'.txt', 'w') as f:
			f.writelines(force_data_lines[force_startLine:i])
		day+=1
		if day>monday[month-1]:
			day=1
			month+=1
		force_startLine=i+1

		lastLine = force_data_lines[i-1]
		lastLine_strs = lastLine.split()
		count = int(lastLine_strs[0])+1

		with open(instance_dir + fileName + '_lai.txt', 'w') as f:
			f.writelines(lai_data_lines[lai_startLine:lai_startLine+count])
		lai_startLine += count+1

			
# Leave State
ms.onLeaveState()

######################################################################

# Run Model
os.system(instance_dir[0:2] + '&&' + 'cd ' + instance_dir + '&&' + 'GWSiB.exe' )

######################################################################

# Enter State
ms.onEnterState('SiB2Output')

# Event - output
ms.onFireEvent('heihecell_output')

output_path = ms.getModelInstanceDirectory()
ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'heihecell.out')

ms.onResponseData()# Event - output

ms.onFireEvent('heiheobs_output')

ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'heiheobs.out')

ms.onResponseData()# Event - output
ms.onFireEvent('heihescan_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'heihescan.out')

ms.onResponseData()# Event - output
ms.onFireEvent('out_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'out.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('out1_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'out1.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('out2_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'out2.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('out3_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'out3.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('out4_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'out4.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('canEG_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'canEG.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('canEI_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'canEI.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('canT_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'canT.txt')

ms.onResponseData()# Event - output
ms.onFireEvent('ETALL_output')


ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'ETALL.txt')

ms.onResponseData()

# Leave State
ms.onLeaveState()
######################################################################

# Enter State
ms.onEnterState('GWSiBOutput')

# Event - output
ms.onFireEvent('inter_output')

output_path = ms.getModelInstanceDirectory()
ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'inter.out')

ms.onResponseData()

# Event - output
ms.onFireEvent('sm_output')

output_path = ms.getModelInstanceDirectory()
ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'heihesm.out')

ms.onResponseData()
# Event - output
ms.onFireEvent('cellsforce_output')

output_path = ms.getModelInstanceDirectory()
ms.setResponseDataFlag(ERequestResponseDataFlag.ERDF_OK)

# Set output format,ERequestResponseDataMIME is the enumeration class of output format
ms.setResponseDataMIME(ERequestResponseDataMIME.ERDM_RAW_FILE)

# Set output path,output_path is the path of output data
ms.setResponseDataBody(output_path + 'cellsforce.out')

ms.onResponseData()
# Leave State
ms.onLeaveState()

ms.onFinalize()